open Gmp
open Genlex

type t = Q.t (* We will use gmp rationals *)



let to_string m  =
  let n,d = (Q.get_num m), (Q.get_den m)  in 
    if (Z.cmp d (Z.from_int 1)) = 0
    then Z.to_string n
    else (
      (Z.to_string n)^"/"^(Z.to_string d)
    )

let of_float = Q.from_float
let of_int  = Q.from_int
let of_int_pair a b = 
  let c1 = Q.from_int a in 
  let c2 = Q.from_int b in 
    Q.div c1 c2

let zero = Q.from_int 0
let one = Q.from_int 1
let minus_one =Q.from_int (-1) 
let mone = minus_one

let compare = Q.compare

let is_zero  = Q.is_zero

let leq a b = (Q.cmp a b) <= 0
let geq a b = (Q.cmp a b) >= 0
let ge a b = (Q.cmp a b ) > 0
let le a b = (Q.cmp a b) < 0
let eq a b = (Q.cmp a b ) = 0
let neq j1 j2 = not (eq j1 j2)
let to_int  q = Z.to_int (Q.get_num q)
let is_int a = true
let num r = Z.to_int(Q.get_num r)
let den r = Z.to_int(Q.get_den r)
let divide = Q.div 
let max a b = if (leq a b) then a else b


let min a b = if (geq a b) then a else b




let add = Q.add
let subtract = Q.sub
let add_int i z = Q.add (Q.from_int i) z
let multiply = Q.mul
let multiply_int i z = Q.mul (Q.from_int i) z


let negate  = Q.neg

(* Implement the parser *)

exception ParseError of string



let lex_tokens = []

let rec parse_coeff = parser
  | [< 'Int n  >] -> of_int n


let of_string s = 
  let lexer = make_lexer lex_tokens in 
  let parsec = parser 
    | [< e=parse_coeff; _=Stream.empty >] -> e 
  in 
    parsec (lexer (Stream.of_string s))




let is_well_behaved c = true
    

