open Sys_lexer
open Sys_parser


module V = VectorSpaceIteration

let degLimit = ref 3 

let parse_file s = 
  try
    let ic = open_in s in 
    let lb = Lexing.from_channel ic in 
    Sys_parser.system Sys_lexer.lexer lb ;
    System.prettyPrint stdout ;
    V.doIt System.global_sys !degLimit
  with 
    | Parsing.Parse_error -> Printf.printf "Parse error line number %d. Rest of file ignored. \n " !linenum 
    | Failure s -> failwith (Printf.sprintf "Failure %s Line number :%d " s !linenum)
	

let _ =  
  Arg.parse [ ("-d", (Arg.Set_int degLimit), "Set degree limit (default 3)")  ]  parse_file "Usage: absSearch [list of files with trs description ] " 


