
module TP :
  sig
    type mon = int array
    val compare_monomials : mon -> mon -> int
    val degree : mon -> int
    module MonOrdering : sig type t = mon val compare : mon -> mon -> int end
    module MMap : Map.S with type key = mon
    type t
    val zero_monomial : int -> mon
    val get_coefficient: t -> mon -> Linexp.t
    val is_zero_monomial : mon -> bool
    val monomial_to_string : mon -> string
    val set_power : int array -> int -> int -> unit
    val add_power : int array -> int -> int -> unit
    val monomial_product : mon -> mon -> mon
    val monomial_product_assign : mon -> mon -> unit
    val padZerosToMonomial : mon -> int -> mon
    val zero : int -> t
    val is_zero : t -> bool
    val const : int -> Linexp.t -> t
    val one : int -> t
    val is_const : t -> bool
    val addTermAssign : Linexp.t * mon -> t -> unit
    val iterForEachTerm : (Linexp.t * mon -> unit) -> t -> unit
    val mapForEachTerm :
      (Linexp.t * mon -> Linexp.t * mon) -> t -> t
    val to_string : t -> string
    val addAssign : t -> t -> unit
    val subAssign : t -> t -> unit
    val copy : t -> t
    val poly_fop : (t -> 'a -> 'b) -> t -> 'a -> t
    val add : t -> t -> t
    val sub : t -> t -> t
    val scaleAssign : Linexp.t * mon -> t -> unit
    val scalePoly : Linexp.t * mon -> t -> t
    val mul : t -> t -> t
    val of_string : int -> string -> t
    val partial : int -> t -> t
    val grad : t -> t list
    val ofMPoly : Mpoly.MP.t -> t
    val scaleMPTerm : Coeff.t * mon -> t -> t
    val product : t -> Mpoly.MP.t -> t
    val createTemplate : int -> int -> (int * t )
    val lieDerivative : Mpoly.MP.t list -> t -> t
    val fPre: Mpoly.MP.t list -> t -> t
    val normalizeTP: t -> Eqs.t -> t
    val collectOverflowTerms: t -> t -> (Linexp.t list)*t
    val instantiateParams: t -> Linexp.t -> Mpoly.MP.t
    val makeTP: int -> (Mpoly.MP.t list) -> (int * t)
    val matchTerms: int -> Eqs.t -> t -> t -> unit
    val encodeMembership: int -> Eqs.t -> Mpoly.MP.t -> t -> unit
  end
